

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>Constructing a model using the Shyft API &mdash; Documentation</title>
  

  
  
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
  
  
  

  
  <script type="text/javascript" src="../../_static/js/modernizr.min.js"></script>
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
        <script src="../../_static/jquery.js"></script>
        <script src="../../_static/underscore.js"></script>
        <script src="../../_static/doctools.js"></script>
        <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
        <script async="async" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.7/latest.js?config=TeX-AMS-MML_HTMLorMML"></script>
        <script type="text/x-mathjax-config">MathJax.Hub.Config({"tex2jax": {"inlineMath": [["$", "$"], ["\\(", "\\)"]], "processEscapes": true, "ignoreClass": "document", "processClass": "math|output_area"}})</script>
        <script src="../../_static/js/bootstrap.min.js"></script>
        <script src="../../_static/js/bootstrap.bundle.min.js"></script>
        <script src="../../_static/js/custom.js"></script>
    
    <script type="text/javascript" src="../../_static/js/theme.js"></script>

    

  
  <link rel="stylesheet" href="../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/css/bootstrap.min.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/css/bootstrap-grid.min.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/css/custom.css" type="text/css" />
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="Running a calibration with SHyFT" href="../nea-example/calibration-configured.html" />
    <link rel="prev" title="Exposing the API" href="../repository/repositories-intro.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../index.html" class="icon icon-home"> Shyft
          

          
          </a>

          
            
            
              <div class="version">
                4.12
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <p class="caption"><span class="caption-text">Project</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/project/what_is_shyft.html">What is Shyft?</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/project/get_involved.html">Get involved</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/project/contact.html">Contact</a></li>
</ul>
<p class="caption"><span class="caption-text">Time Series</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/time_series/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/time_series/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/time_series/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/time_series/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Hydrology</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../../content/hydrology/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/hydrology/concepts.html">Concepts</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="../../content/hydrology/getting_started.html">Getting started</a><ul class="current">
<li class="toctree-l2 current"><a class="reference internal" href="../../content/hydrology/getting_started.html#general-examples">General examples</a><ul class="current">
<li class="toctree-l3"><a class="reference internal" href="../api/api-intro.html">The Shyft <code class="docutils literal notranslate"><span class="pre">api</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../api/api-essentials.html">Essential <code class="docutils literal notranslate"><span class="pre">api</span></code> classes</a></li>
<li class="toctree-l3"><a class="reference internal" href="../repository/repositories-intro.html">Exposing the API</a></li>
<li class="toctree-l3 current"><a class="current reference internal" href="#">Constructing a model using the Shyft API</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#INTRODUCTION">INTRODUCTION</a></li>
<li class="toctree-l4"><a class="reference internal" href="#STEP-0:-LOAD-AND-PLOT-TEST-DATA">STEP 0: LOAD AND PLOT TEST DATA</a></li>
<li class="toctree-l4"><a class="reference internal" href="#STEP-1:-CHOOSE-A-MODEL">STEP 1: CHOOSE A MODEL</a></li>
<li class="toctree-l4"><a class="reference internal" href="#STEP-2:-DEFINE-THE-MODEL-DOMAIN">STEP 2: DEFINE THE MODEL DOMAIN</a></li>
<li class="toctree-l4"><a class="reference internal" href="#STEP-3:-CONFIGURE-THE-MODEL">STEP 3: CONFIGURE THE MODEL</a></li>
<li class="toctree-l4"><a class="reference internal" href="#STEP-4:-CONSTRUCT-THE-REGION-MODEL">STEP 4: CONSTRUCT THE REGION MODEL</a></li>
<li class="toctree-l4"><a class="reference internal" href="#STEP-5:-FEED-FORCING-DATA-TO-THE-REGION-MODEL-BY-CONSTRUCTING-A-REGION-ENVIRONMENT">STEP 5: FEED FORCING DATA TO THE REGION MODEL BY CONSTRUCTING A REGION ENVIRONMENT</a></li>
<li class="toctree-l4"><a class="reference internal" href="#STEP-6:-RUNNING-THE-MODEL">STEP 6: RUNNING THE MODEL</a><ul>
<li class="toctree-l5"><a class="reference internal" href="#1.-The-starting-model-state:-updating-the-current-state-of-the-model">1. The starting model state: updating the current state of the model</a></li>
<li class="toctree-l5"><a class="reference internal" href="#2.-Running-the-interpolation">2. Running the interpolation</a></li>
<li class="toctree-l5"><a class="reference internal" href="#3.-Running-the-model">3. Running the model</a></li>
</ul>
</li>
<li class="toctree-l4"><a class="reference internal" href="#STEP-7:-EXTRACTING-SIMULATION-RESULTS">STEP 7: EXTRACTING SIMULATION RESULTS</a></li>
<li class="toctree-l4"><a class="reference internal" href="#STEP-8:-MODEL-CALIBRATION">STEP 8: MODEL CALIBRATION</a><ul>
<li class="toctree-l5"><a class="reference internal" href="#You’re-done!-You-should-be-able-to-setup-your-own-Shyft-region-model,-calibrate-it,-and-access-simulated-data.-Try-it-out:">You’re done! You should be able to setup your own Shyft region model, calibrate it, and access simulated data. Try it out:</a></li>
</ul>
</li>
<li class="toctree-l4"><a class="reference internal" href="#Exercise">Exercise</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../content/hydrology/getting_started.html#configured-simulation">Configured simulation</a></li>
<li class="toctree-l2"><a class="reference internal" href="../../content/hydrology/getting_started.html#advanced-tools">Advanced tools</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../content/hydrology/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Energy Market</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/energy_market/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/energy_market/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/energy_market/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/energy_market/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Dashboard</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/dashboard/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/dashboard/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/dashboard/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/dashboard/api.html">API Documentation</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">Shyft</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../index.html">Docs</a> &raquo;</li>
        
          <li><a href="../../content/hydrology/getting_started.html">Getting started</a> &raquo;</li>
        
      <li>Constructing a model using the Shyft API</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
            
            <a href="../../_sources/notebooks/shyft-intro-course-master/run_api_model.ipynb.txt" rel="nofollow"> View page source</a>
          
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  
<style>
/* CSS for nbsphinx extension */

/* remove conflicting styling from Sphinx themes */
div.nbinput.container div.prompt *,
div.nboutput.container div.prompt *,
div.nbinput.container div.input_area pre,
div.nboutput.container div.output_area pre,
div.nbinput.container div.input_area .highlight,
div.nboutput.container div.output_area .highlight {
    border: none;
    padding: 0;
    margin: 0;
    box-shadow: none;
}

div.nbinput.container > div[class*=highlight],
div.nboutput.container > div[class*=highlight] {
    margin: 0;
}

div.nbinput.container div.prompt *,
div.nboutput.container div.prompt * {
    background: none;
}

div.nboutput.container div.output_area .highlight,
div.nboutput.container div.output_area pre {
    background: unset;
}

div.nboutput.container div.output_area div.highlight {
    color: unset;  /* override Pygments text color */
}

/* avoid gaps between output lines */
div.nboutput.container div[class*=highlight] pre {
    line-height: normal;
}

/* input/output containers */
div.nbinput.container,
div.nboutput.container {
    display: -webkit-flex;
    display: flex;
    align-items: flex-start;
    margin: 0;
    width: 100%;
}
@media (max-width: 540px) {
    div.nbinput.container,
    div.nboutput.container {
        flex-direction: column;
    }
}

/* input container */
div.nbinput.container {
    padding-top: 5px;
}

/* last container */
div.nblast.container {
    padding-bottom: 5px;
}

/* input prompt */
div.nbinput.container div.prompt pre {
    color: #307FC1;
}

/* output prompt */
div.nboutput.container div.prompt pre {
    color: #BF5B3D;
}

/* all prompts */
div.nbinput.container div.prompt,
div.nboutput.container div.prompt {
    width: 4.5ex;
    padding-top: 5px;
    position: relative;
    user-select: none;
}

div.nbinput.container div.prompt > div,
div.nboutput.container div.prompt > div {
    position: absolute;
    right: 0;
    margin-right: 0.3ex;
}

@media (max-width: 540px) {
    div.nbinput.container div.prompt,
    div.nboutput.container div.prompt {
        width: unset;
        text-align: left;
        padding: 0.4em;
    }
    div.nboutput.container div.prompt.empty {
        padding: 0;
    }

    div.nbinput.container div.prompt > div,
    div.nboutput.container div.prompt > div {
        position: unset;
    }
}

/* disable scrollbars on prompts */
div.nbinput.container div.prompt pre,
div.nboutput.container div.prompt pre {
    overflow: hidden;
}

/* input/output area */
div.nbinput.container div.input_area,
div.nboutput.container div.output_area {
    -webkit-flex: 1;
    flex: 1;
    overflow: auto;
}
@media (max-width: 540px) {
    div.nbinput.container div.input_area,
    div.nboutput.container div.output_area {
        width: 100%;
    }
}

/* input area */
div.nbinput.container div.input_area {
    border: 1px solid #e0e0e0;
    border-radius: 2px;
    /*background: #f5f5f5;*/
}

/* override MathJax center alignment in output cells */
div.nboutput.container div[class*=MathJax] {
    text-align: left !important;
}

/* override sphinx.ext.imgmath center alignment in output cells */
div.nboutput.container div.math p {
    text-align: left;
}

/* standard error */
div.nboutput.container div.output_area.stderr {
    background: #fdd;
}

/* ANSI colors */
.ansi-black-fg { color: #3E424D; }
.ansi-black-bg { background-color: #3E424D; }
.ansi-black-intense-fg { color: #282C36; }
.ansi-black-intense-bg { background-color: #282C36; }
.ansi-red-fg { color: #E75C58; }
.ansi-red-bg { background-color: #E75C58; }
.ansi-red-intense-fg { color: #B22B31; }
.ansi-red-intense-bg { background-color: #B22B31; }
.ansi-green-fg { color: #00A250; }
.ansi-green-bg { background-color: #00A250; }
.ansi-green-intense-fg { color: #007427; }
.ansi-green-intense-bg { background-color: #007427; }
.ansi-yellow-fg { color: #DDB62B; }
.ansi-yellow-bg { background-color: #DDB62B; }
.ansi-yellow-intense-fg { color: #B27D12; }
.ansi-yellow-intense-bg { background-color: #B27D12; }
.ansi-blue-fg { color: #208FFB; }
.ansi-blue-bg { background-color: #208FFB; }
.ansi-blue-intense-fg { color: #0065CA; }
.ansi-blue-intense-bg { background-color: #0065CA; }
.ansi-magenta-fg { color: #D160C4; }
.ansi-magenta-bg { background-color: #D160C4; }
.ansi-magenta-intense-fg { color: #A03196; }
.ansi-magenta-intense-bg { background-color: #A03196; }
.ansi-cyan-fg { color: #60C6C8; }
.ansi-cyan-bg { background-color: #60C6C8; }
.ansi-cyan-intense-fg { color: #258F8F; }
.ansi-cyan-intense-bg { background-color: #258F8F; }
.ansi-white-fg { color: #C5C1B4; }
.ansi-white-bg { background-color: #C5C1B4; }
.ansi-white-intense-fg { color: #A1A6B2; }
.ansi-white-intense-bg { background-color: #A1A6B2; }

.ansi-default-inverse-fg { color: #FFFFFF; }
.ansi-default-inverse-bg { background-color: #000000; }

.ansi-bold { font-weight: bold; }
.ansi-underline { text-decoration: underline; }


div.nbinput.container div.input_area div[class*=highlight] > pre,
div.nboutput.container div.output_area div[class*=highlight] > pre,
div.nboutput.container div.output_area div[class*=highlight].math,
div.nboutput.container div.output_area.rendered_html,
div.nboutput.container div.output_area > div.output_javascript,
div.nboutput.container div.output_area:not(.rendered_html) > img{
    padding: 5px;
    margin: 0;
}

/* fix copybtn overflow problem in chromium (needed for 'sphinx_copybutton') */
div.nbinput.container div.input_area > div[class^='highlight'],
div.nboutput.container div.output_area > div[class^='highlight']{
    overflow-y: hidden;
}

/* hide copybtn icon on prompts (needed for 'sphinx_copybutton') */
.prompt a.copybtn {
    display: none;
}

/* Some additional styling taken form the Jupyter notebook CSS */
div.rendered_html table {
  border: none;
  border-collapse: collapse;
  border-spacing: 0;
  color: black;
  font-size: 12px;
  table-layout: fixed;
}
div.rendered_html thead {
  border-bottom: 1px solid black;
  vertical-align: bottom;
}
div.rendered_html tr,
div.rendered_html th,
div.rendered_html td {
  text-align: right;
  vertical-align: middle;
  padding: 0.5em 0.5em;
  line-height: normal;
  white-space: normal;
  max-width: none;
  border: none;
}
div.rendered_html th {
  font-weight: bold;
}
div.rendered_html tbody tr:nth-child(odd) {
  background: #f5f5f5;
}
div.rendered_html tbody tr:hover {
  background: rgba(66, 165, 245, 0.2);
}

/* CSS overrides for sphinx_rtd_theme */

/* 24px margin */
.nbinput.nblast.container,
.nboutput.nblast.container {
    margin-bottom: 19px;  /* padding has already 5px */
}

/* ... except between code cells! */
.nblast.container + .nbinput.container {
    margin-top: -19px;
}

.admonition > p:before {
    margin-right: 4px;  /* make room for the exclamation icon */
}

/* Fix math alignment, see https://github.com/rtfd/sphinx_rtd_theme/pull/686 */
.math {
    text-align: unset;
}
</style>
<div class="section" id="Constructing-a-model-using-the-Shyft-API">
<h1>Constructing a model using the Shyft API<a class="headerlink" href="#Constructing-a-model-using-the-Shyft-API" title="Permalink to this headline">¶</a></h1>
<div class="section" id="INTRODUCTION">
<h2>INTRODUCTION<a class="headerlink" href="#INTRODUCTION" title="Permalink to this headline">¶</a></h2>
<p>Aim of this notebook is to introduce a Shyft user to Shyft’s API. The Shyft API provides all functionality needed to construct a model, calibrate it, and run it. It is also a great way of learing about the “Shyftonic” way of thinking, i.e. getting to know the architecture of Shyft.</p>
<p>In order to get to know the Shyft API, a very simple model will be constructed in the course of this notebook. The model will be fed with test data, run, and calibrated. In the end it is shown how data can be extracted from the model.</p>
<p>To define a model domain, Shyft uses a number of geo-located sub-units, the cells. Each cell has certain properties like land type fractions (glacier fraction, forest fraction, etc.), area, and geo-location. Cells that belong to the same (sub)catchment have the same catchment ID. The simple model we will construct herein will only hold 1 cell, in order to keep the programming effort at a minimum. Nevertheless will the notebook provide you with the skills needed to setup more complex model
domains, existing of several catchments, each composed from a large number of cells.</p>
<p>Let’s start with importing the Shyft API. The Shyft API gives access to all functionality needed to construct a model. We can import it via …</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[3]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="kn">from</span> <span class="nn">shyft</span> <span class="kn">import</span> <span class="n">api</span> <span class="c1"># import the Shyft API</span>
</pre></div>
</div>
</div>
<p>In addition to the Shyft API, we will import some modules that ease the handling of arrays (numpy module) and plotting (matplotlib library). Besides this, we also import a ready-to-use dataset that provides us with test data that we will use to run the hydrological model.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[4]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span> <span class="c1"># for handling arrays</span>
<span class="kn">from</span> <span class="nn">matplotlib</span> <span class="kn">import</span> <span class="n">pyplot</span> <span class="k">as</span> <span class="n">plt</span> <span class="c1"># for plotting</span>
<span class="kn">from</span> <span class="nn">camels_reader</span> <span class="kn">import</span> <span class="n">TestData</span> <span class="c1"># provides a test data set</span>
</pre></div>
</div>
</div>
<p>We are now set up to use the API for constructing a model. But first let’s take a quick look to the test data we will be using to drive the model.</p>
</div>
<div class="section" id="STEP-0:-LOAD-AND-PLOT-TEST-DATA">
<h2>STEP 0: LOAD AND PLOT TEST DATA<a class="headerlink" href="#STEP-0:-LOAD-AND-PLOT-TEST-DATA" title="Permalink to this headline">¶</a></h2>
<p>Prior to digging into the Shyft API, we will initialize the test dataset. By initiating the TestData Class, a dataset providing all input variables needed to run a hydrological simulation is constructed.</p>
<p>The variables needed to run a model provided by Shyft are standard meteorologic variables: temperature, precipitation, wind speed, relative humidity, and radiation.</p>
<p>In addition to those variables, observed discharged and the total catchment area are provided by the dataset. For now, these information will be enough to construct a simple model aiming to simulate the discharge of the region.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[5]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">data</span> <span class="o">=</span> <span class="n">TestData</span><span class="p">()</span> <span class="c1"># constructs an instance of the TestData Class...</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area stderr docutils container">
<div class="highlight"><pre>
/home/olga/workspace/shyft-doc/notebooks/shyft-intro-course-master/camels_reader.py:30: FutureWarning: read_table is deprecated, use read_csv instead, passing sep=&#39;\t&#39;.
  df = pd.read_table(self.met_filename, skiprows=4, names=keys)
/home/olga/workspace/shyft-doc/notebooks/shyft-intro-course-master/camels_reader.py:42: FutureWarning: read_table is deprecated, use read_csv instead, passing sep=&#39;\t&#39;.
  df = pd.read_table(self.streamflow_filename, names=keys, delim_whitespace=True)
</pre></div></div>
</div>
<p>Let’s have a short look on the variables the data set provides by making some simple plots …</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[6]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">fig</span><span class="p">,</span> <span class="n">ax</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">subplots</span><span class="p">(</span><span class="mi">3</span><span class="p">,</span> <span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">15</span><span class="p">,</span><span class="mi">10</span><span class="p">))</span>
<span class="n">ax</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">data</span><span class="o">.</span><span class="n">temperature</span><span class="p">,</span> <span class="n">label</span><span class="o">=</span><span class="s1">&#39;temperature [deg C]&#39;</span><span class="p">)</span>
<span class="n">ax</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">legend</span><span class="p">(</span><span class="n">loc</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>
<span class="n">ax</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">data</span><span class="o">.</span><span class="n">precipitation</span><span class="p">,</span> <span class="n">label</span><span class="o">=</span><span class="s1">&#39;precipitation [mm/h]&#39;</span><span class="p">)</span>
<span class="n">ax</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">legend</span><span class="p">(</span><span class="n">loc</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>
<span class="n">ax</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">data</span><span class="o">.</span><span class="n">radiation</span><span class="p">,</span> <span class="n">label</span><span class="o">=</span><span class="s1">&#39;radiation [W/2]&#39;</span><span class="p">)</span>
<span class="n">ax</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span><span class="o">.</span><span class="n">legend</span><span class="p">(</span><span class="n">loc</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[6]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
&lt;matplotlib.legend.Legend at 0x7f663344d3c8&gt;
</pre></div></div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../../_images/notebooks_shyft-intro-course-master_run_api_model_9_1.png" src="../../_images/notebooks_shyft-intro-course-master_run_api_model_9_1.png" />
</div>
</div>
<p>We have plotted the test data without time reference. The corresponding time vector is also provided by TestData.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[7]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="nb">print</span><span class="p">(</span><span class="n">data</span><span class="o">.</span><span class="n">time</span><span class="p">)</span>
<span class="c1"># The time is given as UTC timestamp (seconds since January 1 1970). In this exmaple, the delta t between</span>
<span class="c1"># time points is 60*60*3600 seconds. Thus, the dataset provides daily values. By convention, the first data value</span>
<span class="c1"># gives the average value defined by the time span between the first and the second time points given in the time vector.</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
[ 315532800  315619200  315705600 ... 1419811200 1419897600 1419984000]
</pre></div></div>
</div>
</div>
<div class="section" id="STEP-1:-CHOOSE-A-MODEL">
<h2>STEP 1: CHOOSE A MODEL<a class="headerlink" href="#STEP-1:-CHOOSE-A-MODEL" title="Permalink to this headline">¶</a></h2>
<p>Shyft has different model types to offer, each of which is composed of a unique sequence of hydrological methods. We will use the pt_gs_k model, consisting of the Priestly Taylor equation to calculate potential evaportanspiration (PT), a gamma-function based snow routine (GS), and the Kircher method to calculate the discharge response (K).</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[8]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">model_type</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">pt_gs_k</span><span class="o">.</span><span class="n">PTGSKModel</span>

<span class="c1"># Further model options are:</span>

<span class="c1">#model_type = api.pt_ss_k.PTSSKModel</span>
<span class="c1">#model_type = api.pt_ss_k.PTHSKModel</span>
<span class="c1">#model_type = api.hbv_stack.HbvOptModel</span>
<span class="c1">#model_type = api.pt_gs_k.PTGSKOptModel</span>
</pre></div>
</div>
</div>
</div>
<div class="section" id="STEP-2:-DEFINE-THE-MODEL-DOMAIN">
<h2>STEP 2: DEFINE THE MODEL DOMAIN<a class="headerlink" href="#STEP-2:-DEFINE-THE-MODEL-DOMAIN" title="Permalink to this headline">¶</a></h2>
<p>Region, catchment, and cells in Shyft: Configuring the model domain</p>
<p>A Shyft model domain is costructed from cells, which are grouped to catchments using a catchment ID. A cell is characterized by a mid-point (x,y,z), area, land type fractions (glacier, forest, etc), and assigned to a catchment via a catchment ID.</p>
<p>Let’s construct a cell:</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[10]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">x</span><span class="p">,</span> <span class="n">y</span><span class="p">,</span> <span class="n">z</span> <span class="o">=</span> <span class="mi">0</span><span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="mi">0</span>  <span class="c1"># cell center coordinates [m]</span>
<span class="n">area</span> <span class="o">=</span> <span class="n">data</span><span class="o">.</span><span class="n">area</span>  <span class="c1"># cell area [m2]</span>
<span class="n">cid</span> <span class="o">=</span> <span class="mi">1</span>  <span class="c1"># cell&#39;s catchment ID</span>
<span class="n">mid_point</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">GeoPoint</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">y</span><span class="p">,</span> <span class="n">z</span><span class="p">)</span> <span class="c1"># mid point</span>
<span class="n">glacier</span> <span class="o">=</span> <span class="mf">0.0</span>  <span class="c1"># areal glacier fraction</span>
<span class="n">lake</span> <span class="o">=</span> <span class="mf">0.0</span>
<span class="n">reservoir</span> <span class="o">=</span> <span class="mf">0.0</span>
<span class="n">forest</span> <span class="o">=</span> <span class="mf">0.0</span>
<span class="n">unspecified</span> <span class="o">=</span> <span class="mf">1.0</span>  <span class="c1"># residual: 1 - glacier - lake - reservoir - forest</span>
<span class="n">radiation_slope_factor</span> <span class="o">=</span> <span class="mf">1.0</span>  <span class="c1"># A factor to correct radiation input according to the cells orientation</span>
<span class="n">ltf</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">LandTypeFractions</span><span class="p">(</span><span class="n">glacier</span><span class="p">,</span> <span class="n">lake</span><span class="p">,</span> <span class="n">reservoir</span><span class="p">,</span> <span class="n">forest</span><span class="p">,</span> <span class="n">unspecified</span><span class="p">)</span>  <span class="c1"># Class to handle land type fractions</span>
<span class="n">geo_cell_data</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">GeoCellData</span><span class="p">(</span><span class="n">mid_point</span><span class="p">,</span> <span class="n">area</span><span class="p">,</span> <span class="n">cid</span><span class="p">,</span> <span class="n">radiation_slope_factor</span><span class="p">,</span> <span class="n">ltf</span><span class="p">)</span>  <span class="c1"># Handls all cell data</span>
<span class="n">cell</span> <span class="o">=</span> <span class="n">model_type</span><span class="o">.</span><span class="n">cell_t</span><span class="p">()</span>  <span class="c1"># Constructing a cell</span>
<span class="n">cell</span><span class="o">.</span><span class="n">geo</span> <span class="o">=</span> <span class="n">geo_cell_data</span>  <span class="c1"># Feeding the cell with data</span>

<span class="c1"># Append cells to a cell vector... here only shown for the one cell. In more complex scenarios, many more cells are used to define a domain.</span>
<span class="n">cell_vector</span> <span class="o">=</span> <span class="n">model_type</span><span class="o">.</span><span class="n">cell_t</span><span class="o">.</span><span class="n">vector_t</span><span class="p">()</span>
<span class="n">cell_vector</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">cell</span><span class="p">)</span>
</pre></div>
</div>
</div>
</div>
<div class="section" id="STEP-3:-CONFIGURE-THE-MODEL">
<h2>STEP 3: CONFIGURE THE MODEL<a class="headerlink" href="#STEP-3:-CONFIGURE-THE-MODEL" title="Permalink to this headline">¶</a></h2>
<p>Model specific parameters define how the model equations will respond to a certain meteorological forcing. As the parameters are specific to the model type, we can get the correct parameters directly from the model class.</p>
<p>We differ between region parameters (all cells in a domain have the same parameters), and catchment parameters (certain (sub)catchments of the domain can be characterized by a set of model parameters different than the region parameters).</p>
<p>Let’s construct region parameters suiting our model.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[8]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">region_parameter</span> <span class="o">=</span> <span class="n">model_type</span><span class="o">.</span><span class="n">parameter_t</span><span class="p">()</span> <span class="c1"># constructing region parameters</span>

<span class="c1"># and also catchment parameters</span>
<span class="n">catchment_parameters</span> <span class="o">=</span> <span class="n">model_type</span><span class="o">.</span><span class="n">parameter_t</span><span class="o">.</span><span class="n">map_t</span><span class="p">()</span> <span class="c1"># Constructing a parameter map, that maps a set of parameters to a catchment ID</span>
<span class="n">catchment_parameters</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span> <span class="o">=</span> <span class="n">region_parameter</span> <span class="c1"># same type as region parameters. We map catchment parameters to the cell with catchment ID 1</span>
</pre></div>
</div>
</div>
</div>
<div class="section" id="STEP-4:-CONSTRUCT-THE-REGION-MODEL">
<h2>STEP 4: CONSTRUCT THE REGION MODEL<a class="headerlink" href="#STEP-4:-CONSTRUCT-THE-REGION-MODEL" title="Permalink to this headline">¶</a></h2>
<p>The region model combines information about the model domain, or region, which is provided by the cells, and the model we want to use. The link between a region and the model are the region (or catchment) specific model parameters.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[9]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">region_model</span> <span class="o">=</span> <span class="n">model_type</span><span class="p">(</span><span class="n">cell_vector</span><span class="p">,</span> <span class="n">region_parameter</span><span class="p">,</span> <span class="n">catchment_parameters</span><span class="p">)</span> <span class="c1"># needs all the information from above</span>
</pre></div>
</div>
</div>
</div>
<div class="section" id="STEP-5:-FEED-FORCING-DATA-TO-THE-REGION-MODEL-BY-CONSTRUCTING-A-REGION-ENVIRONMENT">
<h2>STEP 5: FEED FORCING DATA TO THE REGION MODEL BY CONSTRUCTING A REGION ENVIRONMENT<a class="headerlink" href="#STEP-5:-FEED-FORCING-DATA-TO-THE-REGION-MODEL-BY-CONSTRUCTING-A-REGION-ENVIRONMENT" title="Permalink to this headline">¶</a></h2>
<p>Before running a simulation, we need to feed forcing data to the region model. This is done by constructing forcing data time series that are geo-located, so called “sources”. In order to create time series of forcing data, we need to define a time axis, and then combine it with the data values.</p>
<p>In order to add sources to the region model, collections of sources of a certain type (temperature, precipitation, …) are organized in SourceVectors. These SourceVectors are then added to the region model.</p>
<p>We first initiate a time-axis from the time points to which the source data corresponds by first constructing a time vector, …</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[10]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">time_vec</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">UtcTimeVector</span><span class="p">(</span><span class="n">data</span><span class="o">.</span><span class="n">time</span><span class="p">)</span> <span class="c1"># convert the interger array to a shyft time vector</span>
</pre></div>
</div>
</div>
<p>… and then constructing a time axis:</p>
<p>A time axis if a set if non-overlapping periods. The time points give the start and end points of those periods. In order to have the same amount of perdios as data values, we need to add one more time point in order to mark the end point of the last period of the time axis. Since the time resultution of our data is daily, we simply add 60<em>60</em>24 seconds to the last time point provided to define the end point of the last interval.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[11]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">time_end</span> <span class="o">=</span> <span class="n">time_vec</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="o">+</span> <span class="mi">60</span><span class="o">*</span><span class="mi">60</span><span class="o">*</span><span class="mi">24</span> <span class="c1"># end of last time interval</span>
</pre></div>
</div>
</div>
<p>We now have all information needed to construct a time axis …</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[12]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">ta_srs</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">TimeAxisByPoints</span><span class="p">(</span><span class="n">time_vec</span><span class="p">,</span> <span class="n">t_end</span><span class="o">=</span><span class="n">time_end</span><span class="p">)</span>
</pre></div>
</div>
</div>
<p>… and make a time series by combining the data values with the corresponding time axis.</p>
<p>Since the data values represent daily average values, we tell the constructor that it should interprete the values as avarage values, by using the point interpretation policy provided by Shyft’s API (api.POINT_AVERAGE_VALUE). Another option would be api.POINT_INSTANT_VALUE, used in cases where the measured values represent instant values</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[13]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">t_ts</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">TimeSeries</span><span class="p">(</span><span class="n">ta_srs</span><span class="p">,</span> <span class="n">api</span><span class="o">.</span><span class="n">DoubleVector</span><span class="o">.</span><span class="n">from_numpy</span><span class="p">(</span><span class="n">data</span><span class="o">.</span><span class="n">temperature</span><span class="p">),</span> <span class="n">api</span><span class="o">.</span><span class="n">POINT_AVERAGE_VALUE</span><span class="p">)</span>  <span class="c1"># time series</span>
</pre></div>
</div>
</div>
<p>We then do exactly the same for rest of the model forcing variables:</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[14]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">p_ts</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">TimeSeries</span><span class="p">(</span><span class="n">ta_srs</span><span class="p">,</span> <span class="n">api</span><span class="o">.</span><span class="n">DoubleVector</span><span class="o">.</span><span class="n">from_numpy</span><span class="p">(</span><span class="n">data</span><span class="o">.</span><span class="n">precipitation</span><span class="p">),</span> <span class="n">api</span><span class="o">.</span><span class="n">POINT_AVERAGE_VALUE</span><span class="p">)</span>
<span class="n">ws_ts</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">TimeSeries</span><span class="p">(</span><span class="n">ta_srs</span><span class="p">,</span> <span class="n">api</span><span class="o">.</span><span class="n">DoubleVector</span><span class="o">.</span><span class="n">from_numpy</span><span class="p">(</span><span class="n">data</span><span class="o">.</span><span class="n">wind_speed</span><span class="p">),</span> <span class="n">api</span><span class="o">.</span><span class="n">POINT_AVERAGE_VALUE</span><span class="p">)</span>
<span class="n">rh_ts</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">TimeSeries</span><span class="p">(</span><span class="n">ta_srs</span><span class="p">,</span> <span class="n">api</span><span class="o">.</span><span class="n">DoubleVector</span><span class="o">.</span><span class="n">from_numpy</span><span class="p">(</span><span class="n">data</span><span class="o">.</span><span class="n">relative_humidity</span><span class="p">),</span> <span class="n">api</span><span class="o">.</span><span class="n">POINT_AVERAGE_VALUE</span><span class="p">)</span>
<span class="n">r_ts</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">TimeSeries</span><span class="p">(</span><span class="n">ta_srs</span><span class="p">,</span> <span class="n">api</span><span class="o">.</span><span class="n">DoubleVector</span><span class="o">.</span><span class="n">from_numpy</span><span class="p">(</span><span class="n">data</span><span class="o">.</span><span class="n">radiation</span><span class="p">),</span> <span class="n">api</span><span class="o">.</span><span class="n">POINT_AVERAGE_VALUE</span><span class="p">)</span>
</pre></div>
</div>
</div>
<p>We now declare the geo locations of our time series. For simplicity, we just use the same location for all time series. The coordinates must to be based on an orthogonal corrdinate system (e.g. UTM).</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[15]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">geop</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">GeoPoint</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span><span class="mi">0</span><span class="p">,</span><span class="mi">0</span><span class="p">)</span> <span class="c1"># x,y,z location</span>
</pre></div>
</div>
</div>
<p>Finally, we have all information needed to construct variable-type specific sources by linking geo location and time series:</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[16]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">t_srs</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">TemperatureSource</span><span class="p">(</span><span class="n">geop</span><span class="p">,</span> <span class="n">t_ts</span><span class="p">)</span>
<span class="n">p_srs</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">PrecipitationSource</span><span class="p">(</span><span class="n">geop</span><span class="p">,</span> <span class="n">p_ts</span><span class="p">)</span>
<span class="n">ws_srs</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">WindSpeedSource</span><span class="p">(</span><span class="n">geop</span><span class="p">,</span> <span class="n">ws_ts</span><span class="p">)</span>
<span class="n">rh_srs</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">RelHumSource</span><span class="p">(</span><span class="n">geop</span><span class="p">,</span> <span class="n">rh_ts</span><span class="p">)</span>
<span class="n">r_srs</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">RadiationSource</span><span class="p">(</span><span class="n">geop</span><span class="p">,</span> <span class="n">r_ts</span><span class="p">)</span>
</pre></div>
</div>
</div>
<p>In this example, we just provide one source per input variable.</p>
<p>However, the most common case is that we have many geo-located time series per forcing variable, e.g. from several obervational stations in a region or from a gridded forcing data set (numerical weather forecasting model, climate model, gridded observations, etc).</p>
<p>Before we can feed the sources to the model, we therefore need to construct source vectors, which are collections of sources of the same variable type (temperature, precipitation, …).</p>
<p>Again: for simplicity only one source per vector is appended in this example. Accordingly, many sources with different geo locations could be added to the same vector.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[17]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># constructing the source vectors</span>
<span class="n">t_srs_vec</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">TemperatureSourceVector</span><span class="p">([</span><span class="n">t_srs</span><span class="p">])</span>
<span class="n">p_srs_vec</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">PrecipitationSourceVector</span><span class="p">([</span><span class="n">p_srs</span><span class="p">])</span>
<span class="n">ws_srs_vec</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">WindSpeedSourceVector</span><span class="p">([</span><span class="n">ws_srs</span><span class="p">])</span>
<span class="n">rh_srs_vec</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">RelHumSourceVector</span><span class="p">([</span><span class="n">rh_srs</span><span class="p">])</span>
<span class="n">r_srs_vec</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">RadiationSourceVector</span><span class="p">([</span><span class="n">r_srs</span><span class="p">])</span>
</pre></div>
</div>
</div>
<p>All information about sources is organized in the region environment. The region environment is the part of the region model and contains all geo-located sources.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[18]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># constructing a region environment from the environment sources:</span>
<span class="n">region_env</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">ARegionEnvironment</span><span class="p">()</span>
<span class="n">region_env</span><span class="o">.</span><span class="n">temperature</span> <span class="o">=</span> <span class="n">t_srs_vec</span>
<span class="n">region_env</span><span class="o">.</span><span class="n">precipitation</span> <span class="o">=</span> <span class="n">p_srs_vec</span>
<span class="n">region_env</span><span class="o">.</span><span class="n">wind_speed</span> <span class="o">=</span> <span class="n">ws_srs_vec</span>
<span class="n">region_env</span><span class="o">.</span><span class="n">rel_hum</span> <span class="o">=</span> <span class="n">rh_srs_vec</span>
<span class="n">region_env</span><span class="o">.</span><span class="n">radiation</span> <span class="o">=</span> <span class="n">r_srs_vec</span>
</pre></div>
</div>
</div>
<p>Now that we have created a region environment holding all geo-located time series that we want to use as model forcing, we are ready to update the region model with the freshly costructed region environment:</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[19]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">region_model</span><span class="o">.</span><span class="n">region_env</span> <span class="o">=</span> <span class="n">region_env</span>
</pre></div>
</div>
</div>
</div>
<div class="section" id="STEP-6:-RUNNING-THE-MODEL">
<h2>STEP 6: RUNNING THE MODEL<a class="headerlink" href="#STEP-6:-RUNNING-THE-MODEL" title="Permalink to this headline">¶</a></h2>
<p>In order to be able to run the model, two more requirements need to be fulfilled:</p>
<ol class="arabic simple">
<li><p>Initial values for state variables need to be defined. The starting state needs to be defined in order to make future predictions of the model state, e.g., tomorrow’s amount of snow in a cell can only be calculated if today’s amount of snow is known. The amount of snow is a typical state variable and needs to be set prior to a model run in order to enable a quality calculation forward in time.</p></li>
<li><p>Since the model-stack is executed cell-by-cell, the source variables (or model forcing variables: temperature, etc..) need to be interpolated from the source locations to the cell locations, so that <strong>each cell holds a complete set of forcing variables. These are then used to run the model cell-by-cell</strong>.</p></li>
</ol>
<p>After providing these steps, the is ready to run.</p>
<div class="section" id="1.-The-starting-model-state:-updating-the-current-state-of-the-model">
<h3>1. The starting model state: updating the current state of the model<a class="headerlink" href="#1.-The-starting-model-state:-updating-the-current-state-of-the-model" title="Permalink to this headline">¶</a></h3>
<p>We first construct a state that suits to the model. The state will be constructed with default values for each state varibale.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[20]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">state</span> <span class="o">=</span> <span class="n">region_model</span><span class="o">.</span><span class="n">state_t</span><span class="p">()</span>
</pre></div>
</div>
</div>
<p>We can update state variables by simply setting the variables to desired values.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[21]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">state</span><span class="o">.</span><span class="n">kirchner</span><span class="o">.</span><span class="n">q</span> <span class="o">=</span> <span class="mf">0.8</span> <span class="c1"># Setting the initial discharge value of the kirchner routine</span>
</pre></div>
</div>
</div>
<p>The model needs to keep track of which state belongs to which cell. This can be achieved using the state_with_id state type. You can think of it as a geo-referenced model state, mapping a certain state to a cell. A collection of states_with_id can be managed with a state_with_id_vct, the state_with_id vector.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[22]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">state_with_id</span> <span class="o">=</span> <span class="n">region_model</span><span class="o">.</span><span class="n">state_with_id_t</span><span class="p">()</span> <span class="c1"># constructing the state_with_id</span>
<span class="n">state_with_id_vct</span> <span class="o">=</span> <span class="n">region_model</span><span class="o">.</span><span class="n">state_with_id_t</span><span class="o">.</span><span class="n">vector_t</span><span class="p">()</span> <span class="c1"># constructing the state_with_id vector</span>
<span class="n">state_with_id</span><span class="o">.</span><span class="n">state</span> <span class="o">=</span> <span class="n">state</span> <span class="c1"># set the state</span>
<span class="n">state_with_id</span><span class="o">.</span><span class="n">id</span> <span class="o">=</span> <span class="n">state_with_id</span><span class="o">.</span><span class="n">cell_state</span><span class="p">(</span><span class="n">cell</span><span class="o">.</span><span class="n">geo</span><span class="p">)</span> <span class="c1"># mapping it to the cell</span>
<span class="n">state_with_id_vct</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">state_with_id</span><span class="p">)</span> <span class="c1"># append it to the vector. As we only constructed a one-cell model at the moment,</span>
                                        <span class="c1"># we only need to append this one cell.</span>
</pre></div>
</div>
</div>
<p>We now can update the region model with the cell states, by passing the state vector to the apply_state() method. Only cells that have a catchment ID that is member of the list passed as second argument are updated.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[23]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">region_model</span><span class="o">.</span><span class="n">state</span><span class="o">.</span><span class="n">apply_state</span><span class="p">(</span><span class="n">state_with_id_vct</span><span class="p">,</span> <span class="p">[</span><span class="mi">1</span><span class="p">])</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[23]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
&lt;shyft.api._api.IntVector at 0xf20ae6bc30&gt;
</pre></div></div>
</div>
<p>Let’s check if the value of the state variable that we just tried to update is actually applied.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[24]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="nb">print</span><span class="p">(</span><span class="n">region_model</span><span class="o">.</span><span class="n">current_state</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">kirchner</span><span class="o">.</span><span class="n">q</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
0.8
</pre></div></div>
</div>
<p>The current state will change as the model steps forward in time and always represent the model state after the last time stepping. Because it changes, it makes sense to store the initial state (which is to this point the current state of the model), so that it later can be re-set as current state, e.g. in order to repeat simulations under the same conditions.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[25]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">region_model</span><span class="o">.</span><span class="n">initial_state</span> <span class="o">=</span> <span class="n">region_model</span><span class="o">.</span><span class="n">current_state</span>
</pre></div>
</div>
</div>
<p>Since computation time is costly, it is possible to disable/enable the collection of state variables for catchments. Disabling state collection leads to a faster performance of the model, however, the time series of state variables are not stored in memmory during a model run, and thus not accessible after a simulation. Let’s enable state collection for this simulation.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[26]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">region_model</span><span class="o">.</span><span class="n">set_state_collection</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="kc">True</span><span class="p">)</span> <span class="c1"># Enabling state collection for all cells with catchment ID 1</span>
</pre></div>
</div>
</div>
</div>
<div class="section" id="2.-Running-the-interpolation">
<h3>2. Running the interpolation<a class="headerlink" href="#2.-Running-the-interpolation" title="Permalink to this headline">¶</a></h3>
<p>Before running the interpolation, we need to initiate the cell environment. This constructs the environment variables at the cell level at the temporal resolution of a time axis argument.</p>
<p>After initiation, all values of the environment variables at the cell level are set to zero.</p>
<p>The interpolation step will then fill each cell’s environment variable time series based on the time series provided in the sources, and in dependence of a set of interpolation parameters, that define how the interpolation is conducted.</p>
<p>Let’s first construct the simulation time axis …</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[27]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">utc</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">Calendar</span><span class="p">()</span> <span class="c1"># shyft.api calendar, nice for keeping track of time</span>
<span class="n">n_steps</span> <span class="o">=</span> <span class="mi">365</span><span class="o">*</span><span class="mi">20</span> <span class="c1"># number of steps</span>
<span class="n">ta_sim</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">TimeAxis</span><span class="p">(</span><span class="n">utc</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">1990</span><span class="p">,</span> <span class="mi">9</span><span class="p">,</span> <span class="mi">1</span><span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="mi">0</span><span class="p">),</span> <span class="n">api</span><span class="o">.</span><span class="n">deltahours</span><span class="p">(</span><span class="mi">24</span><span class="p">),</span> <span class="mi">365</span><span class="o">*</span><span class="mi">20</span><span class="p">)</span>  <span class="c1"># simulation time axis, 20 year at daily resolution</span>
</pre></div>
</div>
</div>
<p>… and then initialize the cell environment:</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[28]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">region_model</span><span class="o">.</span><span class="n">initialize_cell_environment</span><span class="p">(</span><span class="n">ta_sim</span><span class="p">)</span>
</pre></div>
</div>
</div>
<p>Let’s now run the interpolation:</p>
<p>The interpolation spatially and temporally interpolates the environment variables from sources (charcterized by the by time axis ta_srs and geo-location) to the cells (characterized by time axis ta_sim and the cell’s mid-point). The region_model was constructed with default interpolation parameters, which we can use for the interpolation.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[29]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">region_model</span><span class="o">.</span><span class="n">interpolate</span><span class="p">(</span><span class="n">region_model</span><span class="o">.</span><span class="n">interpolation_parameter</span><span class="p">,</span> <span class="n">region_model</span><span class="o">.</span><span class="n">region_env</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[29]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
True
</pre></div></div>
</div>
</div>
<div class="section" id="3.-Running-the-model">
<h3>3. Running the model<a class="headerlink" href="#3.-Running-the-model" title="Permalink to this headline">¶</a></h3>
<p>Let’s finally run the model forward in time, as defined by time axis ta_sim.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[30]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">region_model</span><span class="o">.</span><span class="n">run_cells</span><span class="p">()</span>
</pre></div>
</div>
</div>
</div>
</div>
<div class="section" id="STEP-7:-EXTRACTING-SIMULATION-RESULTS">
<h2>STEP 7: EXTRACTING SIMULATION RESULTS<a class="headerlink" href="#STEP-7:-EXTRACTING-SIMULATION-RESULTS" title="Permalink to this headline">¶</a></h2>
<p>Model results (and states) are <strong>storded in memmory</strong> (and not written to file, as you might know it from other models) and can be accessed via the region model. Results can be accessed cell-by-cell, or aggregated at the catchment level. The latter is calculated on demand. A list of catchment IDs can be passed that define which cells should be included in the aggregation.</p>
<p>Some of the results can be accessed via the “statistics” attribute of the region model. Let’s have a look at the discharge:</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[31]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">q</span> <span class="o">=</span> <span class="n">region_model</span><span class="o">.</span><span class="n">statistics</span><span class="o">.</span><span class="n">discharge</span><span class="p">([</span><span class="mi">1</span><span class="p">])</span> <span class="c1"># A TimeSeries object is returned: the discharge aggregated over cells with ID 1</span>
                                           <span class="c1"># Reminder: We have already learned about TimeSeries further up in this notebook</span>
</pre></div>
</div>
</div>
<p>The values of a TimeSeries object can be accessed as follows:</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[32]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">q_vals</span> <span class="o">=</span> <span class="n">q</span><span class="o">.</span><span class="n">values</span>
</pre></div>
</div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[33]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Let&#39;s plot the discharge</span>
</pre></div>
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[34]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">fig</span><span class="p">,</span> <span class="n">ax</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">subplots</span><span class="p">(</span><span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">10</span><span class="p">,</span><span class="mi">5</span><span class="p">))</span>
<span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">q_vals</span><span class="p">,</span> <span class="n">label</span><span class="o">=</span><span class="s2">&quot;discharge [m3 s-1]&quot;</span><span class="p">)</span>
<span class="n">ax</span><span class="o">.</span><span class="n">legend</span><span class="p">()</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[34]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
&lt;matplotlib.legend.Legend at 0xf20b087fd0&gt;
</pre></div></div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../../_images/notebooks_shyft-intro-course-master_run_api_model_72_1.png" src="../../_images/notebooks_shyft-intro-course-master_run_api_model_72_1.png" />
</div>
</div>
<p>So far, the model has been run with default model parameters. <strong>Let’s now calibrate the model.</strong></p>
</div>
<div class="section" id="STEP-8:-MODEL-CALIBRATION">
<h2>STEP 8: MODEL CALIBRATION<a class="headerlink" href="#STEP-8:-MODEL-CALIBRATION" title="Permalink to this headline">¶</a></h2>
<p>In order to estimate model parameters, a discharge time series is required that is used to evaluate the simulated discharge.</p>
<p>The test dataset offers observed discharge for the test region. Let’s use it to create the evaluation time series, the so called target:</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[35]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Target time series from all discharge observations available:</span>
<span class="n">ts_trg_all</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">TimeSeries</span><span class="p">(</span><span class="n">ta_srs</span><span class="p">,</span> <span class="n">data</span><span class="o">.</span><span class="n">discharge</span><span class="p">,</span> <span class="n">api</span><span class="o">.</span><span class="n">POINT_AVERAGE_VALUE</span><span class="p">)</span>
</pre></div>
</div>
</div>
<p>If we would like to limit the evaluation to only a part of the simulation, we can subset the target time series by defining a new time axis, that only covers a part of the simulation period:</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[36]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># subset time series to desired time axis for calibration</span>
<span class="n">ta_trg</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">TimeAxis</span><span class="p">(</span><span class="n">utc</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">1991</span><span class="p">,</span> <span class="mi">9</span><span class="p">,</span> <span class="mi">1</span><span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="mi">0</span><span class="p">),</span> <span class="n">api</span><span class="o">.</span><span class="n">deltahours</span><span class="p">(</span><span class="mi">24</span><span class="p">),</span> <span class="mi">365</span><span class="o">*</span><span class="mi">18</span><span class="p">)</span>  <span class="c1"># simulation time axis, 18 years</span>
<span class="n">ts_trg</span> <span class="o">=</span> <span class="n">ts_trg_all</span><span class="o">.</span><span class="n">average</span><span class="p">(</span><span class="n">ta_trg</span><span class="p">)</span>
</pre></div>
</div>
</div>
<p>The model needs to know the area that is represented by the target time series. For this reason, “target specifications” are used to combine a target time series with additional properties characterizing the target:</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[37]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># make target specification vector</span>
<span class="n">calc_type</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">TargetSpecCalcType</span><span class="p">(</span><span class="mi">0</span><span class="p">)</span> <span class="c1"># Which goal function you want to use; 0 is Nash-Sutcliffe</span>
<span class="n">cids</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">IntVector</span><span class="o">.</span><span class="n">from_numpy</span><span class="p">([</span><span class="mi">1</span><span class="p">])</span> <span class="c1"># a list with IDs to let the model know which catchments the target represents</span>
<span class="n">weight</span> <span class="o">=</span> <span class="mi">1</span> <span class="c1"># Here we have only one target time series. If you have many, you need to tell the model how to weighten them during calibration</span>
<span class="n">target_specification</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">TargetSpecificationPts</span><span class="p">(</span><span class="n">ts_trg</span><span class="p">,</span> <span class="n">cids</span><span class="p">,</span> <span class="n">weight</span><span class="p">,</span> <span class="n">calc_type</span><span class="p">)</span> <span class="c1"># construct the target specification</span>
</pre></div>
</div>
</div>
<p>You can make as many target specifications as you want. They can represent different areas and cover different periods. A collection of target specifications is organized via target specification vectors:</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[38]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">target_spec_vec</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">TargetSpecificationVector</span><span class="p">()</span>
<span class="n">target_spec_vec</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">target_specification</span><span class="p">)</span>
</pre></div>
</div>
</div>
<p>As the model will run simulations over and over again during calibration in order to try out differnt parameter sets, it is advantageous if the model runs as fast as possible. Collecting time series of state and response variables slows a model down. As many of these variables are not needed during calibration (e.g. herein, we only use discharge to calibrate the model), Shyft offers an optimized model type that can be used for calibration. This model will discard most of the response and state
variables as it steps forwards in time. You can construct an optimized model from the already ready-to-use region model:</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[39]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">region_model_opt</span> <span class="o">=</span> <span class="n">region_model</span><span class="o">.</span><span class="n">create_opt_model_clone</span><span class="p">()</span>
</pre></div>
</div>
</div>
<p>In order to run a calibration, we also need to define the parameter ranges between which the optimization routine should search for an optimal parameter. Let’s construct 3 region model parameter sets: one to define the lower bound parameters, one to define the upper bound parameters, and one which gives the starting values of the parameters, from which an optimization run will start.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[40]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">p_min</span> <span class="o">=</span> <span class="n">region_model_opt</span><span class="o">.</span><span class="n">parameter_t</span><span class="p">()</span>
<span class="n">p_max</span> <span class="o">=</span> <span class="n">region_model_opt</span><span class="o">.</span><span class="n">parameter_t</span><span class="p">()</span>
<span class="n">p_init</span> <span class="o">=</span> <span class="n">region_model_opt</span><span class="o">.</span><span class="n">parameter_t</span><span class="p">()</span>
</pre></div>
</div>
</div>
<p>So far, the parameter objects are filled with default values. Let’s set the ranges of some key parameters…</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[41]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># make a difference in parameter range</span>
<span class="n">p_min</span><span class="o">.</span><span class="n">kirchner</span><span class="o">.</span><span class="n">c1</span><span class="p">,</span> <span class="n">p_max</span><span class="o">.</span><span class="n">kirchner</span><span class="o">.</span><span class="n">c1</span><span class="p">,</span> <span class="n">p_init</span><span class="o">.</span><span class="n">kirchner</span><span class="o">.</span><span class="n">c1</span> <span class="o">=</span> <span class="o">-</span><span class="mi">8</span><span class="p">,</span> <span class="o">-</span><span class="mi">1</span><span class="p">,</span> <span class="o">-</span><span class="mi">3</span>  <span class="c1"># kirchner response parameter</span>
<span class="n">p_min</span><span class="o">.</span><span class="n">kirchner</span><span class="o">.</span><span class="n">c2</span><span class="p">,</span> <span class="n">p_max</span><span class="o">.</span><span class="n">kirchner</span><span class="o">.</span><span class="n">c2</span><span class="p">,</span> <span class="n">p_init</span><span class="o">.</span><span class="n">kirchner</span><span class="o">.</span><span class="n">c2</span> <span class="o">=</span> <span class="mf">0.05</span><span class="p">,</span> <span class="mf">1.0</span><span class="p">,</span> <span class="mf">0.4</span>  <span class="c1"># kirchner response parameter</span>
<span class="n">p_min</span><span class="o">.</span><span class="n">kirchner</span><span class="o">.</span><span class="n">c3</span><span class="p">,</span> <span class="n">p_max</span><span class="o">.</span><span class="n">kirchner</span><span class="o">.</span><span class="n">c3</span><span class="p">,</span> <span class="n">p_init</span><span class="o">.</span><span class="n">kirchner</span><span class="o">.</span><span class="n">c3</span> <span class="o">=</span> <span class="o">-</span><span class="mi">1</span><span class="p">,</span> <span class="o">-</span><span class="mf">0.01</span><span class="p">,</span> <span class="o">-</span><span class="mf">1.0</span>  <span class="c1"># kirchner response parameter</span>

<span class="n">p_min</span><span class="o">.</span><span class="n">gs</span><span class="o">.</span><span class="n">tx</span><span class="p">,</span> <span class="n">p_max</span><span class="o">.</span><span class="n">gs</span><span class="o">.</span><span class="n">tx</span><span class="p">,</span> <span class="n">p_init</span><span class="o">.</span><span class="n">gs</span><span class="o">.</span><span class="n">tx</span> <span class="o">=</span> <span class="o">-</span><span class="mi">3</span><span class="p">,</span> <span class="mi">5</span><span class="p">,</span> <span class="mi">0</span>  <span class="c1"># gamma snow, rain/snow threshold temperature [deg. C]</span>
<span class="n">p_min</span><span class="o">.</span><span class="n">gs</span><span class="o">.</span><span class="n">wind_const</span><span class="p">,</span> <span class="n">p_max</span><span class="o">.</span><span class="n">gs</span><span class="o">.</span><span class="n">wind_const</span><span class="p">,</span> <span class="n">p_init</span><span class="o">.</span><span class="n">gs</span><span class="o">.</span><span class="n">wind_const</span> <span class="o">=</span> <span class="mi">0</span><span class="p">,</span> <span class="mi">3</span><span class="p">,</span> <span class="mf">1.5</span>  <span class="c1"># wind scaling for turbulent flux calculations</span>
<span class="n">p_min</span><span class="o">.</span><span class="n">gs</span><span class="o">.</span><span class="n">wind_scale</span><span class="p">,</span> <span class="n">p_max</span><span class="o">.</span><span class="n">gs</span><span class="o">.</span><span class="n">wind_scale</span><span class="p">,</span> <span class="n">p_init</span><span class="o">.</span><span class="n">gs</span><span class="o">.</span><span class="n">wind_scale</span> <span class="o">=</span> <span class="mi">1</span><span class="p">,</span> <span class="mi">6</span><span class="p">,</span> <span class="mi">3</span>  <span class="c1"># wind scaling for turbulent flux calculations</span>

<span class="n">p_min</span><span class="o">.</span><span class="n">p_corr</span><span class="o">.</span><span class="n">scale_factor</span><span class="p">,</span> <span class="n">p_max</span><span class="o">.</span><span class="n">p_corr</span><span class="o">.</span><span class="n">scale_factor</span><span class="p">,</span> <span class="n">p_init</span><span class="o">.</span><span class="n">p_corr</span><span class="o">.</span><span class="n">scale_factor</span> <span class="o">=</span> <span class="mf">0.5</span><span class="p">,</span> <span class="mf">1.2</span><span class="p">,</span> <span class="mi">1</span>  <span class="c1"># precipitation scaling</span>

<span class="n">p_min</span><span class="o">.</span><span class="n">ae</span><span class="o">.</span><span class="n">ae_scale_factor</span><span class="p">,</span> <span class="n">p_max</span><span class="o">.</span><span class="n">ae</span><span class="o">.</span><span class="n">ae_scale_factor</span><span class="p">,</span> <span class="n">p_init</span><span class="o">.</span><span class="n">ae</span><span class="o">.</span><span class="n">ae_scale_factor</span> <span class="o">=</span> <span class="mf">0.5</span><span class="p">,</span> <span class="mf">1.5</span><span class="p">,</span> <span class="mi">1</span> <span class="c1"># actual evapo scaling</span>
</pre></div>
</div>
</div>
<p>Each optimized model offers an optimizer Class that offers functionality to run an automized calibration. Let’s construct it:</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[42]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">optimizer</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">pt_gs_k</span><span class="o">.</span><span class="n">PTGSKOptModel</span><span class="o">.</span><span class="n">optimizer_t</span><span class="p">(</span><span class="n">region_model_opt</span><span class="p">)</span>
</pre></div>
</div>
</div>
<p>Remember the target we specified earlier? Let’s make the otimizer aware of the target, parameter ranges, and the parameter starting values:</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[43]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">optimizer</span><span class="o">.</span><span class="n">target_specification</span> <span class="o">=</span> <span class="n">target_spec_vec</span>
<span class="n">optimizer</span><span class="o">.</span><span class="n">parameter_lower_bound</span> <span class="o">=</span> <span class="n">p_min</span>
<span class="n">optimizer</span><span class="o">.</span><span class="n">parameter_upper_bound</span> <span class="o">=</span> <span class="n">p_max</span>
<span class="n">optimizer</span><span class="o">.</span><span class="n">set_verbose_level</span><span class="p">(</span><span class="mi">1</span><span class="p">)</span>
</pre></div>
</div>
</div>
<p>We finally can run a calibration!</p>
<p>The optimizer will return an optimized set of parameters once it found the (hopefully) best set of parameters:</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[44]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Calibrating ...&quot;</span><span class="p">)</span>
<span class="n">opt_params</span> <span class="o">=</span> <span class="n">optimizer</span><span class="o">.</span><span class="n">optimize</span><span class="p">(</span><span class="n">p_init</span><span class="p">,</span> <span class="mi">1500</span><span class="p">,</span> <span class="mf">0.2</span><span class="p">,</span> <span class="mf">1e-5</span><span class="p">)</span> <span class="c1"># calibrateing ... this can take a little while...</span>
<span class="nb">print</span><span class="p">(</span><span class="s2">&quot;... done!&quot;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Calibrating ...
... done!
</pre></div></div>
</div>
<p>Let’s run the model one more time. This time with optimized parameters:</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[45]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Running the model with optimized parameters</span>
<span class="n">NSE</span> <span class="o">=</span> <span class="mi">1</span><span class="o">-</span><span class="n">optimizer</span><span class="o">.</span><span class="n">calculate_goal_function</span><span class="p">(</span><span class="n">opt_params</span><span class="p">)</span>
<span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Nash-Sutcliffe efficiency: &quot;</span><span class="p">,</span> <span class="n">NSE</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Nash-Sutcliffe efficiency:  0.7696042047891952
</pre></div></div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[46]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Accessing the simulated discharge ...</span>
<span class="n">q_opt</span> <span class="o">=</span> <span class="n">region_model_opt</span><span class="o">.</span><span class="n">statistics</span><span class="o">.</span><span class="n">discharge</span><span class="p">([])</span>
</pre></div>
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[47]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># and plot it, together with the observed discharge:</span>
<span class="n">fig</span><span class="p">,</span> <span class="n">ax</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">subplots</span><span class="p">(</span><span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">15</span><span class="p">,</span><span class="mi">8</span><span class="p">))</span>
<span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">q_opt</span><span class="o">.</span><span class="n">time_axis</span><span class="o">.</span><span class="n">time_points</span><span class="p">[:</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span> <span class="n">q_opt</span><span class="o">.</span><span class="n">values</span><span class="p">,</span> <span class="n">label</span><span class="o">=</span><span class="s1">&#39;sim&#39;</span><span class="p">)</span>
<span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">ts_trg</span><span class="o">.</span><span class="n">time_axis</span><span class="o">.</span><span class="n">time_points</span><span class="p">[:</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span> <span class="n">ts_trg</span><span class="o">.</span><span class="n">values</span><span class="p">,</span> <span class="n">label</span><span class="o">=</span><span class="s1">&#39;obs&#39;</span><span class="p">)</span>
<span class="n">ax</span><span class="o">.</span><span class="n">set_ylim</span><span class="p">([</span><span class="mi">0</span><span class="p">,</span> <span class="mi">1000</span><span class="p">])</span>
<span class="n">ax</span><span class="o">.</span><span class="n">legend</span><span class="p">()</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[47]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
&lt;matplotlib.legend.Legend at 0xf20c1efe10&gt;
</pre></div></div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../../_images/notebooks_shyft-intro-course-master_run_api_model_98_1.png" src="../../_images/notebooks_shyft-intro-course-master_run_api_model_98_1.png" />
</div>
</div>
<div class="section" id="You’re-done!-You-should-be-able-to-setup-your-own-Shyft-region-model,-calibrate-it,-and-access-simulated-data.-Try-it-out:">
<h3>You’re done! You should be able to setup your own Shyft region model, calibrate it, and access simulated data. Try it out:<a class="headerlink" href="#You’re-done!-You-should-be-able-to-setup-your-own-Shyft-region-model,-calibrate-it,-and-access-simulated-data.-Try-it-out:" title="Permalink to this headline">¶</a></h3>
</div>
</div>
<div class="section" id="Exercise">
<h2>Exercise<a class="headerlink" href="#Exercise" title="Permalink to this headline">¶</a></h2>
<p>Construct a region model with 4 cells. Cell 1 and 2 should have catchment ID 1 and cell 3 and 4 should have catchment ID 2, and the following properties: * cell 1 should have an area of 3390 km2, x=0, y=0, z=0 * cell 2 should have an area of 565 km2, x=80000, y=0, z=0 * cell 3 should have an area of 2260 km2, x=0, y=80000, z=0 * cell 4 should have an area of 565 km2, x=80000, 80000, z=0</p>
<p>There are no glaciers, lakes, and reservoirs in the region, but cell 1 is to 50% covered by forest.</p>
<p>Find an optimized set of model parameters for the region (assume that he observed discharge represents the combined discharge of catchment 1 and 2).</p>
<p>Use the optimized region parameters from the calibration in order to simulate the discharge of the region, and of catchment 1 and 2.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[48]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Start coding here ...</span>
</pre></div>
</div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span>
</pre></div>
</div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span>
</pre></div>
</div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[ ]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span>
</pre></div>
</div>
</div>
</div>
</div>


           </div>
           
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="../nea-example/calibration-configured.html" class="btn btn-neutral float-right" title="Running a calibration with SHyFT" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right"></span></a>
      
      
        <a href="../repository/repositories-intro.html" class="btn btn-neutral float-left" title="Exposing the API" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2021, The Shyft project

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/rtfd/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>